(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.Counter = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
'use strict';

const Promise = require('./promise.js');

/**
 * Module to distribute function calls in a timeframe
 */
const Distribution = function () {
    this._callbacks = [];    
    this.timeframe = 1000;
};

module.exports = Distribution;

/**
 * Method to add a callback
 * @param {function} callback
 */
Distribution.prototype.add = function (callback) 
{
    if (typeof callback !== 'function') {
        return console.error('Given callback is not a function.');
    }

    this._callbacks.push(callback);
    return this;
};

/**
 * Method to define the timeframe
 * @param  {number} milliseconds
 * @return {Distribution}
 */
Distribution.prototype.in = function (milliseconds)
{
    if (typeof milliseconds !== 'number') {
        return console.error('Given timeframe value is not a number.');
    }

    this.timeframe = milliseconds;
    return this;
};

/**
 * Method to run the distribution
 */
Distribution.prototype.run = function ()
{
    var self = this;

    if (this._callbacks.length === 0) {
        return console.error('No methods defined.');
    }

    return new Promise(
        function (resolve, reject) {
            try {
                self._callbacks.reverse();
                let today = new Date().getTime();
                let start = today;
                var end = today + self.timeframe;
                let timeframe = end - start;
                let interval = Math.ceil(timeframe / self._callbacks.length);

                var timing = setInterval(
                    function () {
                        self._callbacks.pop().call();
                        if (self._callbacks.length === 0) {
                            clearInterval(timing);
                            resolve(self);
                        }
                    },
                    interval
                );
            } catch (err) {
                reject(err)
            }        
        }
    );
};
},{"./promise.js":2}],2:[function(require,module,exports){
'use strict';

/**
 * Module to immitate a simpler version of promise
 * @param {function} callback
 */
const Promise = function (callback) {
    this._resolve = function () {};
    this._reject = function (err) {return console.error(err);};
    this._callback = callback;

    var self = this;
    setTimeout(
        function () {
            self._callback.call(self, self._resolve, self._reject);
        },
        16
    );
};

module.exports = Promise;

/**
 * Method to define the resolve callback
 * @param  {function} callback
 * @return {Promise}
 */
Promise.prototype.resolve = function (callback) {
    if (typeof callback !== 'function') {
        return console.error('`resolve` callback needs to be a function.');
    }

    this._resolve = callback;
    return this;
};

/**
 * Method to define the reject callback
 * @param  {function} callback
 * @return {Promise}
 */
Promise.prototype.reject = function (callback) {
    if (typeof callback !== 'function') {
        return console.error('`reject` callback needs to be a function.');
    }

    this._reject = callback;
    return this;
};
},{}],3:[function(require,module,exports){
'use strict';

/**
 * Module to count up
 */
var Counter = function () 
{
    this.distribution = new (require('distribute-js'))();
    this.number = 0;
    this.display = 0;
    this.time = 1000;
    this.animated = false;
    this._onTick = function () {};
    this._onEnd = function () {};
};

module.exports = Counter;

/**
 * Method to set the number to count to
 * @param  {integer} number
 * @return {Counter}
 */
Counter.prototype.count = function (number)
{
    this.number = number;
    return this;
};

/**
 * Method to enable animated counting
 * @return {Counter}
 */
Counter.prototype.animate = function ()
{
    this.animated = true;
    return this;
};

/**
 * Method to set the time in which the counting should be done
 * @param  {integer} milliseconds
 * @return {Counter}
 */
Counter.prototype.in = function (milliseconds)
{
    this.time = milliseconds;
    return this;
};

/**
 * Method to trigger a tick callback that processes a countup
 * @return {Counter}
 */
Counter.prototype.tick = function ()
{
    this.display++;
    this._onTick(this.display);    
    return this;
};

/**
 * Method to set the `onUpdate` callback which will be triggered on each countup
 * @param  {function} callback
 * @return {Counter}
 */
Counter.prototype.onUpdate = function (callback) {
    if (typeof callback !== 'function') {
        return console.error('`onUpdate` callback needs to be a function.');
    }
    this._onTick = callback;
    return this;
};

/**
 * Method to set the `onDone` callback which will be triggered after the counting goal is reached
 * @param  {Function} callback
 * @return {Counter}
 */
Counter.prototype.onDone = function (callback) {
    if (typeof callback !== 'function') {
        return console.error('`onDone` callback needs to be a function.');
    }

    this._onEnd = callback;
    return this;
}

/**
 * Method to start the coutup
 */
Counter.prototype.run = function ()
{
    if (this.animated !== true) {
        this.display = this.number - 1;
        this.tick();
    } else {
        for (let counter = 0; counter < this.number; counter++) {        
            this.distribution.add(this.tick.bind(this));
        }
        let promise = this.distribution.in(this.time).run();
        promise.resolve(this._onEnd);
    }
};
},{"distribute-js":1}]},{},[3])(3)
});