'use strict';

const counter = new (require(__dirname + '/../src/counter.js'))();
const assert = require('assert');

describe(
    'Counter', 
    function () {
        describe(
            '#count',
            function () {
                it (
                    'should set the counter number to the given number', 
                    function () {
                        assert.equal(1000, counter.count(1000).number);
                        assert.equal(250, counter.count(250).number);
                        assert.equal(3, counter.count(3).number);
                    }
                );
            }
        );
        describe(
            '#animate',
            function () {
                it(
                    'should set the animated flag to `true`',
                    function () {
                        assert.equal(true, counter.animate().animated);
                    }
                )
            }
        );
        describe(
            '#in',
            function () {
                it(
                    'should set the timeframe in which the counting should be happening',
                    function () {
                        assert.equal(1000, counter.in(1000).time);
                        assert.equal(1500, counter.in(1500).time);
                    }
                )
            }
        );
        describe(
            '#run',
            function () {
                this.timeout(2000);
                it(
                    'should start the counting',
                    function (done) {
                        var current = 0;

                        counter.onTick = function (newNumber) {
                            current = newNumber;
                        };

                        counter.run();                        
                        setTimeout(
                            function () {
                                assert.equal(0, current);
                                done();
                            },
                            1500
                        );                    
                    }
                )
            }
        );
    }
);